#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "inifile.h"
#include "f75111.h"
#include <stdio.h>
#include <unistd.h>
#include <sys/io.h>
#include <stdlib.h>

gint WDTTimer ;
gint m_CountDown ;

extern GtkStatusIcon *tray_icon;
extern gboolean m_IsWDTLoop;
extern gboolean m_IsInstall;
extern gboolean m_IsF75111;

gboolean CheckDIOLow_End;


void
on_Dlg_Main_destroy                    (GtkObject       *object,
                                        gpointer         user_data)
{
    if(m_IsInstall)
        SaveFile();
    // In order to prevent rebooting while single test WDT
    F75111_SetWDTDisable();
    gtk_main_quit();
}

void
on_button_DIO_Start_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
    if( m_IsF75111 )
    {
        CheckDIOLow_End = FALSE;

        // Start thread for dio test
        g_thread_create(CheckDIO_Low, NULL, FALSE, NULL);
        g_thread_create(CheckDIO_High, NULL, FALSE, NULL);
    }
    else
    {
        // show error message of init F75111 fail
        GtkWidget *MessageInitialize;
        MessageInitialize = gtk_message_dialog_new( NULL,
                                                                            GTK_DIALOG_MODAL,
                                                                            GTK_MESSAGE_INFO,
                                                                            GTK_BUTTONS_CLOSE,
                                                                            "\n Init F75111 Fail!!\n");
          gtk_widget_show(MessageInitialize);

          g_signal_connect_swapped(MessageInitialize,
                               "response",
                               G_CALLBACK(gtk_widget_destroy),
                               MessageInitialize);
    }
}

void CheckDIO_Low()
{
    int dwValue, dwRead ;
    gdouble m_ProgressLowValue;
    char text[100];

    // initize the editbox
    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DO_0), FALSE);
    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DO_1), FALSE);
    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DO_2), FALSE);
    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DO_3), FALSE);
    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DI_0), FALSE);
    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DI_1), FALSE);
    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DI_2), FALSE);
    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DI_3), FALSE);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DO_0), FALSE);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DO_1), FALSE);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DO_2), FALSE);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DO_3), FALSE);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DI_0), FALSE);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DI_1), FALSE);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DI_2), FALSE);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DI_3), FALSE);

    // initize the progressbar
    gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(progressbar_Low), 0);
    gtk_progress_bar_set_text(GTK_PROGRESS_BAR(progressbar_Low), "0 %");

    // Start test DI/DO  bit by bit
    for (dwValue = 0; dwValue <16 ; dwValue++)
    {
        F75111_SetDigitalOutput(dwValue);
        usleep(100000);

        dwRead = F75111_GetDigitalInput() & 0x0F;

        m_ProgressLowValue = (dwValue *7) ;

        sprintf(text, "%d %%", (int) m_ProgressLowValue);

        if( m_ProgressLowValue >95 )
        {
            gtk_progress_bar_set_text(GTK_PROGRESS_BAR(progressbar_Low), "100%");
            gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(progressbar_Low), 1);
        }
        else
        {
            gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(progressbar_Low), m_ProgressLowValue /100);
            gtk_progress_bar_set_text(GTK_PROGRESS_BAR(progressbar_Low), text);
        }

        if(dwValue == dwRead)
        {
            if((dwValue & 0x01) == 1)
            {
                gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DO_0), TRUE);
            }

             if((dwRead & 0x01) == 1)
            {
                gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DI_0), TRUE);
            }

            if((dwValue & 0x02) == 2)
            {
                gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DO_1), TRUE);
            }

             if((dwRead & 0x02) == 2)
            {
                gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DI_1), TRUE);
            }

             if((dwValue & 0x04) == 4)
            {
                gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DO_2), TRUE);
            }

            if((dwRead & 0x04) == 4)
            {
                gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DI_2), TRUE);
            }

             if((dwValue & 0x08) == 8)
            {
                gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DO_3), TRUE);
            }

             if((dwRead & 0x08) == 8)
            {
                gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DI_3), TRUE);
            }
        }

        if( dwValue != dwRead )
        {

            usleep(50000);
            dwRead = F75111_GetDigitalInput() & 0x0F;

            if( dwValue != dwRead )
            {
                if((dwValue & 0x01) == 1)
                {
                    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DO_0), TRUE);
                }

                if((dwRead & 0x01) == 1)
                {
                    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DI_0), TRUE);
                }

                if((dwValue & 0x02) == 2)
                {
                    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DO_1), TRUE);
                }

                if((dwRead & 0x02) == 2)
                {
                    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DI_1),TRUE);
                }

                if((dwValue & 0x04) == 4)
                {
                    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DO_2), TRUE);
                }

                if((dwRead & 0x04) == 4)
                {
                    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DI_2), TRUE);
                }

                if((dwValue & 0x08) == 8)
                {
                    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DO_3), TRUE);
                }

                 if((dwRead & 0x08) == 8)
                {
                    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DI_3), TRUE);
                }
            }       // if( dwValue != dwRead )  end of second check
        }           // if( dwValue != dwRead )  end of first check
    }               // end of dio loop
    CheckDIOLow_End = TRUE;
}

void CheckDIO_High()        // function the same with CheckDIO_Low but high bit
{
    gdouble m_ProgressHighValue;
    int dwValue, dwRead;
    char text[100];

    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DO_4), FALSE);
    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DO_5), FALSE);
    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DO_6), FALSE);
    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DO_7), FALSE);
    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DI_4), FALSE);
    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DI_5), FALSE);
    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DI_6), FALSE);
    gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DI_7), FALSE);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DO_4), FALSE);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DO_5), FALSE);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DO_6), FALSE);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DO_7), FALSE);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DI_4), FALSE);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DI_5), FALSE);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DI_6), FALSE);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DI_7), FALSE);

    // initize the progressbar
    gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(progressbar_High), 0);
    gtk_progress_bar_set_text(GTK_PROGRESS_BAR(progressbar_High), "0 %");
    while(TRUE)
    {  g_usleep(10000);
        // g_print("while\n");
        if(CheckDIOLow_End)
        {//   g_print("end\n");
            for (dwValue = 0; dwValue <16 ; dwValue++)
            {
                F75111_SetDigitalOutput(dwValue*16);
                usleep(100000);

                dwRead = (F75111_GetDigitalInput() & 0xF0) >> 4;

                m_ProgressHighValue = (gdouble) ( dwValue *7 );

                sprintf(text, "%d %%", (int) m_ProgressHighValue);

                if( m_ProgressHighValue >95 )
                {
                    gtk_progress_bar_set_text(GTK_PROGRESS_BAR(progressbar_High), "100%");
                    gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(progressbar_High), 1);
                }
                else
                {
                    gtk_progress_bar_set_text(GTK_PROGRESS_BAR(progressbar_High), text);
                    gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(progressbar_High), m_ProgressHighValue/100);
                }

                if( dwValue == dwRead)
                {
                    if((dwValue & 0x01) == 1)
                    {
                        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DO_4), TRUE);
                    }

                    if((dwRead & 0x01) == 1)
                    {
                        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DI_4), TRUE);
                    }

                    if((dwValue & 0x02) == 2)
                    {
                        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DO_5), TRUE);
                    }

                    if((dwRead & 0x02) == 2)
                    {
                        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DI_5), TRUE);
                    }

                    if((dwValue & 0x04) == 4)
                    {
                        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DO_6), TRUE);
                    }

                    if((dwRead & 0x04) == 4)
                    {
                        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DI_6), TRUE);
                    }

                    if((dwValue & 0x08) == 8)
                    {
                        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DO_7), TRUE);
                    }

                     if((dwRead & 0x08) == 8)
                    {
                        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_DI_7), TRUE);
                    }
                }

                if( dwValue != dwRead)
                {
                    usleep(50000);
                    dwRead = (F75111_GetDigitalInput() & 0xF0) >> 4;

                    if( dwValue != dwRead)
                    {
                        if((dwValue & 0x01) == 1)
                        {
                            gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DO_4), TRUE);
                        }

                        if((dwRead & 0x01) == 1)
                        {
                            gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DI_4), TRUE);
                        }

                        if((dwValue & 0x02) == 2)
                        {
                            gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DO_5), TRUE);
                        }

                        if((dwRead & 0x02) == 2)
                        {
                            gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DI_5), TRUE);
                        }

                        if((dwValue & 0x04) == 4)
                        {
                            gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DO_6), TRUE);
                        }

                        if((dwRead & 0x04) == 4)
                        {
                            gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DI_6), TRUE);
                        }

                        if((dwValue & 0x08) == 8)
                        {
                            gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DO_7), TRUE);
                        }

                        if((dwRead & 0x08) == 8)
                        {
                            gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(checkbutton_DI_7),TRUE);
                        }
                    }   // if( dwValue != dwRead )  end of Second check
                }       // if( dwValue != dwRead )  end of First check
            }           // end of dio loop
            break;
        }               // end of "CheckDIO_End"
    }                   // end of "While Loop"
}

void
on_button_WDTEnable_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
    if(!m_IsF75111)
    {
        // show error message of init F75111 fail
        GtkWidget *MessageInitialize;
        MessageInitialize = gtk_message_dialog_new( NULL,
                                                                            GTK_DIALOG_MODAL,
                                                                            GTK_MESSAGE_INFO,
                                                                            GTK_BUTTONS_CLOSE,
                                                                            "\n Init F75111 Fail!!\n");
          gtk_widget_show(MessageInitialize);

          g_signal_connect_swapped(MessageInitialize,
                               "response",
                               G_CALLBACK(gtk_widget_destroy),
                               MessageInitialize);
    }
    else
    {
        // get timer
        const gchar * tmp = gtk_entry_get_text(GTK_ENTRY(entry_WDTTimer));

        gint timer ;
        // transfer string to integer
        timer = atoi(tmp);
        m_CountDown = timer;

        // only accept timer from 0 to 255, show error message if timer over this range
        if(timer<= 0 || timer >255)
        {
            GtkWidget *MessageTimerValue;
            MessageTimerValue = gtk_message_dialog_new( NULL,
                                                                                    GTK_DIALOG_MODAL,
                                                                                    GTK_MESSAGE_INFO,
                                                                                    GTK_BUTTONS_CLOSE,
                                                                                    "\n Please input the number between 0-255 \n");
            gtk_widget_show(MessageTimerValue);

            g_signal_connect_swapped(MessageTimerValue,
                                                    "response",
                                                    G_CALLBACK(gtk_widget_destroy),
                                                    MessageTimerValue);
            return;
        }

        // disable "Enable button", "Timer editbox" and "WDT Loop checkbox"
        gtk_widget_set_sensitive(button_WDTEnable                  , FALSE);
        gtk_widget_set_sensitive(entry_WDTTimer                     , FALSE);
        gtk_widget_set_sensitive(checkbutton_EnableWDTLoop   , FALSE);

        // enable the disable button
        gtk_widget_set_sensitive(button_WDTDisable, TRUE);

        // Blinking the icon
        gtk_status_icon_set_blinking(GTK_STATUS_ICON(tray_icon), TRUE);

        // Setting countdown timer to reboot
        F75111_SetWDTEnable(timer);
        WDTTimer = gtk_timeout_add(1000, (GtkFunction)WDTCountDown, NULL);

    }
}

// WDT Timer
gboolean WDTCountDown()
{
    char StatusText[100];

    if(!m_IsWDTLoop)
    {
        // count down
        m_CountDown -- ;
        // set status text
        sprintf(StatusText, " %d seconds later will reboot ", m_CountDown );
        gtk_label_set_text(GTK_LABEL (label_WDTStatus), StatusText);
    }
    else    // Loop test
    {
        if(m_CountDown  >= 2)
        {
            m_CountDown --;
            // set status text
            sprintf(StatusText, " %d seconds later will reboot ", m_CountDown );
            gtk_label_set_text(GTK_LABEL (label_WDTStatus), StatusText);
        }
        else
        {
            // stop timer
            gtk_timeout_remove(WDTTimer);

            // disable wdt in timer -1 second
            F75111_SetWDTDisable();
            // set status text
            sprintf(StatusText, " WDT got DISABLE signal ");
            gtk_label_set_text(GTK_LABEL (label_WDTStatus), StatusText);

            usleep(1000000);

            // Get timer again
            const gchar * tmp = gtk_entry_get_text(GTK_ENTRY(entry_WDTTimer));
            gint timer ;
            timer = atoi(tmp);

            m_CountDown = timer;
            // Start timer and enable WDT
            F75111_SetWDTEnable(timer);
            WDTTimer = gtk_timeout_add(1000, (GtkFunction)WDTCountDown, NULL);
        }
    }
    return TRUE;
}

void
on_button_WDTDisable_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
    char StatusText[100];

    // Disable WDT
    F75111_SetWDTDisable();
    // Stop Timer
    gtk_timeout_remove(WDTTimer);
    // Enable "Enable button", "WDT timer editbox", "WDT Loop checkbox"
    gtk_widget_set_sensitive(button_WDTEnable                  , TRUE);
    gtk_widget_set_sensitive(entry_WDTTimer                     , TRUE);
    gtk_widget_set_sensitive(checkbutton_EnableWDTLoop   , TRUE);
    // Disable "Disable button"
    gtk_widget_set_sensitive(button_WDTDisable, FALSE);

    // Set status test
    sprintf(StatusText, " WDT got DISABLE signal ");
    gtk_label_set_text(GTK_LABEL (label_WDTStatus), StatusText);

    // Stop  tray icon blinking
    gtk_status_icon_set_blinking(tray_icon, FALSE);
}

void
on_button_Install_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
    m_IsInstall = TRUE;

    if(g_file_test("/root/F75111demo/F75111", G_FILE_TEST_EXISTS) == FALSE)
    {
        system("mkdir -p /root/F75111demo");
        system("cp -f ./F75111 /root/F75111demo/F75111");
        system("cp -f ./F75111.desktop /root/F75111demo/F75111.desktop");
    }

    g_usleep(100000);
    SaveFile();

    if(g_file_test("/root/F75111demo/F75111.desktop", G_FILE_TEST_EXISTS) == TRUE)
    {
        system("mkdir -p /root/.config/autostart");
        system("cp -f ./F75111.desktop /root/.config/autostart/F75111.desktop");
    }
    else
    {
        GtkWidget *MsgInstallError;
        MsgInstallError = gtk_message_dialog_new( NULL,
                                                                        GTK_DIALOG_MODAL,
                                                                        GTK_MESSAGE_INFO,
                                                                        GTK_BUTTONS_CLOSE,
                                                                        "\n Install Error !! Lost F75111.desktop file \n");
        gtk_widget_show(MsgInstallError);

        g_signal_connect_swapped(MsgInstallError,
                                                "response",
                                                G_CALLBACK(gtk_widget_destroy),
                                                MsgInstallError);
        return ;
    }

    GtkWidget *MessageInstall;
    MessageInstall = gtk_message_dialog_new( NULL,
                                                                    GTK_DIALOG_MODAL,
                                                                    GTK_MESSAGE_INFO,
                                                                    GTK_BUTTONS_CLOSE,
                                                                    "\n Install succeed!!\n");
    gtk_widget_show(MessageInstall);

    g_signal_connect_swapped(MessageInstall,
                                            "response",
                                            G_CALLBACK(gtk_widget_destroy),
                                            MessageInstall);
}

void
on_button_Uninstall_clicked            (GtkButton      *button,
                                        gpointer         user_data)
{
    // remove file
    system("rm -f /root/.config/autostart/F75111.desktop");
    system("rm -f /root/F75111demo/F75111.ini");
    m_IsInstall = FALSE;

    GtkWidget *MessageUninstall;
    MessageUninstall = gtk_message_dialog_new( NULL,
                                                                        GTK_DIALOG_MODAL,
                                                                        GTK_MESSAGE_INFO,
                                                                        GTK_BUTTONS_CLOSE,
                                                                        "\n Uninstall succeed!!\n");
    gtk_widget_show(MessageUninstall);

    g_signal_connect_swapped(MessageUninstall,
                                            "response",
                                            G_CALLBACK(gtk_widget_destroy),
                                            MessageUninstall);
}

void
on_checkbutton_EnableWDTLoop_toggled   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
    // check WDT loop button toggled or not
    if(gtk_toggle_button_get_active (togglebutton))
        m_IsWDTLoop = TRUE;
    else
        m_IsWDTLoop = FALSE;
}

void SaveFile()
{
    char strWDTTimer[5], strAddress[5];
    IniFile *ini;
    ini = ini_file_new();

    // Install or not
    if(m_IsInstall)
        ini_file_write_boolean(ini, "Permanent", "install", TRUE);
    else
        ini_file_write_boolean(ini, "Permanent", "install", FALSE);

    // Write WDT Loop enable or not
    if(m_IsWDTLoop)
        ini_file_write_boolean( ini, "Information", "WDTLoop", TRUE );
    else
        ini_file_write_boolean( ini, "Information", "WDTLoop", FALSE );

    // Write WDT timer to ini
    sprintf(strWDTTimer, "%s", gtk_entry_get_text(GTK_ENTRY(entry_WDTTimer)));
    ini_file_write_string( ini, "Information", "WDTTimer", strWDTTimer);

    // Write F75111 address to ini
    sprintf(strAddress, "%s", gtk_entry_get_text(GTK_ENTRY(entry_Address)));
    ini_file_write_string( ini, "Information", "F75111_Address", strAddress);

    ini_file_write_file( ini, "/root/F75111demo/F75111.ini");
    ini_file_free(ini);
}



