#ifndef _INI_FILE_
#define _INI_FILE_
#include <glib.h>

gboolean m_IsInstall;
gboolean m_IsWDTLoop ;

typedef struct
{
    gchar *key;
    gchar *value;
}IniLine;

typedef struct
{
    gchar *name;
    GList *lines;
}IniSection;

typedef struct
{
    gchar *filename;
    GList *sections;
    gboolean m_IsChanged;
}IniFile;

IniFile* ini_file_new();
IniFile* ini_file_open_file(gchar* filename);

gboolean ini_file_write_file(IniFile* ini, gchar* filename);
void ini_file_free(IniFile *ini);

// read value
gboolean ini_file_read_string(IniFile* ini, gchar* section, gchar* key, gchar** value);
gboolean ini_file_read_int(IniFile* ini, gchar* section, gchar* key, gint* value);
gboolean ini_file_read_boolean(IniFile* ini, gchar* section, gchar* key, gboolean* value);

// write value
void ini_file_write_string(IniFile* ini, gchar* section, gchar* key, gchar* value);
void ini_file_write_int(IniFile* ini, gchar* section, gchar* key, gint value);
void ini_file_write_boolean(IniFile* ini, gchar* section, gchar* key, gboolean value);
#endif
