/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"
#include "inifile.h"
#include "f75111.h"

#include <stdio.h>
#include <unistd.h>
#include <sys/io.h>

BYTE F75111_Address1 ;
extern  void on_button_WDTEnable_clicked ();

GtkStatusIcon *tray_icon;
gboolean m_IsF75111;

// Convert the address for F75111 init
BYTE StringToByte (char * strAddress)
{
    gint x;
    sscanf(strAddress, "%x ", &x);
	return x ;
}

void ReadConfig()
{
    gboolean bIsInstall, bIsWDTLoop;
    char *strAddress;
    char *strWDTTimer;
    IniFile *ini;

    ini = ini_file_open_file("/root/F75111demo/F75111.ini");

    // Get Install or not
    if((ini_file_read_boolean( ini, "Permanent", "install", &bIsInstall)))
    {
        if(!bIsInstall)
        {
            m_IsInstall = FALSE ;
            return;
        }
        else
            m_IsInstall = TRUE ;
    }

    // Setting F75111 address
    if(ini_file_read_string( ini, "Information", "F75111_Address", &strAddress));
    {
        gtk_entry_set_text( GTK_ENTRY(entry_Address), strAddress);
    }

    // Setting timer of WDT . (No matter looping or not)
    if(ini_file_read_string( ini, "Information", "WDTTimer", &strWDTTimer))
    {
        gtk_entry_set_text( GTK_ENTRY(entry_WDTTimer), strWDTTimer);
    }

    // Get WDT Loop enable or not.  Start Loop test if get WDT loop enable signal
    if(ini_file_read_boolean(ini, "Information", "WDTLoop", &bIsWDTLoop))
    {
        if(bIsWDTLoop)
        {
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_EnableWDTLoop), TRUE);
        }
        else
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_EnableWDTLoop), FALSE);
    }

    g_free(ini);
}

// show dialog while tray icon was clicked
void tray_icon_on_click (GtkStatusIcon *status_icon,
                        gpointer user_data)
{
    gtk_window_deiconify (GTK_WINDOW(Dlg_Main));
    gtk_widget_show (Dlg_Main);
}

// show dialog while tray icon was clicked
void tray_icon_on_menu (GtkStatusIcon *status_icon, guint button,
                       guint activate_time, gpointer user_data)
{
    gtk_window_deiconify (GTK_WINDOW(Dlg_Main));
    gtk_widget_show (Dlg_Main);
}

static GtkStatusIcon *create_tray_icon()
{
    tray_icon = gtk_status_icon_new();

    // setting signal of left button click
    g_signal_connect(G_OBJECT(tray_icon),
                            "activate",
                            G_CALLBACK(tray_icon_on_click),
                            NULL);

    // setting signal of right button click
    g_signal_connect(G_OBJECT(tray_icon),
                              "popup-menu",
                              G_CALLBACK(tray_icon_on_menu),
                              NULL);

    // set icon look, tooltip, visable
    gtk_status_icon_set_from_icon_name(tray_icon,GTK_STOCK_PREFERENCES);
    gtk_status_icon_set_tooltip(tray_icon, "F75111 v2.0");
    gtk_status_icon_set_visible(tray_icon, TRUE);

    return tray_icon;
}

// tarce the status of dialog
void callback(gpointer data)
{
        GtkWidget *window=GTK_WIDGET(data);

        // dialog minimal;
        if(gdk_window_get_state(GDK_WINDOW(window->window)) == 1<<1)
            gtk_widget_hide(Dlg_Main);
}

int
main (int argc, char *argv[])
{
    // Get jurisdiction to write ( IMPORTANT )
    iopl(3);

  GtkWidget *Dlg_Main;

#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  gtk_set_locale ();

  // initial thread
  if(!g_thread_supported())
        g_thread_init(NULL);

  gtk_init(&argc, &argv);

  // Create tray icon
  tray_icon = create_tray_icon();

 // add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");

  Dlg_Main = create_Dlg_Main ();
  gtk_widget_show (Dlg_Main);
  gtk_window_set_position(GTK_WINDOW(Dlg_Main),GTK_WIN_POS_CENTER);

  // connect the minimal dialog signal
  g_signal_connect_swapped(Dlg_Main,"window_state_event",
                           G_CALLBACK(callback),Dlg_Main);

  // setting dialog information if config file found
  if(g_file_test("/root/F75111demo/F75111.ini", G_FILE_TEST_EXISTS) == TRUE)
  {
      ReadConfig();
  }

  // convert the address from editbox
  m_F75111.bAddress = StringToByte((char *)gtk_entry_get_text( GTK_ENTRY( entry_Address )) );

  // initialize the F75111, show the error message if init fail.
  if (!F75111_Init())
  {
      m_IsF75111 = FALSE;
  }
  else
  {
    m_IsF75111 = TRUE;
  }

  if(m_IsWDTLoop)
    on_button_WDTEnable_clicked();

  gdk_threads_enter();
  // start main loop
  gtk_main ();
  gdk_threads_leave();

  return 0;
}

